'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function () {
  var defaultOptions = {
    root: '',
    prefix: '~'
  };

  var visitor = {
    ImportDeclaration: function ImportDeclaration(path) {
      var state = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

      var originalPath = path.node.source.value;
      var options = Object.assign({}, defaultOptions, state.opts);

      validateOptions(options);

      if (hasPrefix(originalPath, options.prefix)) {
        path.node.source.value = _path2.default.join(babelRoot, options.root, originalPath.slice(options.prefix.length));
      }
    }
  };

  return { visitor: visitor };
};

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _slash = require('slash');

var _slash2 = _interopRequireDefault(_slash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var babelRoot = process.cwd();

function validateOptions(options) {
  ensureString(options, 'root');
  ensureString(options, 'prefix');
}

function ensureString(object, key) {
  if (typeof object[key] !== 'string') throw new Error('Expected ' + key + ' to be a String, found ' + object[key]);
}

function hasPrefix(path, prefix) {
  return (0, _slash2.default)(path).startsWith(prefix + '/');
}